unit uPrint;

interface

uses
{$IFDEF WIN32}
  Windows,
{$ENDIF}
  Math, xMatDefs,
  uExcelFile,  XLConst,
  sysutils, uAuxiliares, uFechas, ComObj,
  Graphics;

type
  TTipoGrafico = ({linea, }dispersion, areaApilada);
  TDAOfTTipoGrafico = array of TTipoGrafico;
  TTipoEje = (Primario, Secundario);
  TDAOfTTipoEje = array of TTipoEje;
  TTipoValoresAComparar = (Promedios, DesviacionesEstandar, ProbabilidadesDeExcedencia);
  TDAOfTColor = array of TColor;

const
  colorAutomatico = clDefault; //TODO ver la forma de que dllexcel use colorAutomatico y no clDefault

function nroColToExcelStrCol(nroCol: Integer) : String;

procedure WriteMatToText(
  nombreArch: string;
  mat: TMatOfNReal;
  titulo: string;
  nPasos: integer;
  nCronicas: integer;
  dtFechaPrimerPaso: TDateTime;
  dtPaso: double;
  digitos, decimales: integer;
  Print_Todas: boolean;
  Print_promedio: boolean;
  Print_probAisladas: TDAofNReal );

procedure chartMat(xls: TExcelFile;
                   nombreHoja: String; titulo, ejeY: String;
                   colIni, colFin, filaIni, filaFin: Integer;
                   minEjeYAuto, maxEjeYAuto: boolean;
                   minEjeY, MaxEjeY: NReal;
                   minEjeX, MaxEjeX: NReal;
                   tipoGrafico: TTipoGrafico); overload;

procedure chartMat(xls: TExcelFile;
                   nombreHoja: String; titulo, ejeY: String;
                   colIni, colFin, filaIni, filaFin: Integer;
                   minEjeYAuto, maxEjeYAuto: boolean;
                   minEjeY, MaxEjeY: NReal;
                   minEjeX, MaxEjeX: NReal;
                   tiposGraficos: TDAOfTTipoGrafico;
                   ejes: TDAOfTTipoEje;
                   colores: TDAOfTColor); overload;



(* ??? por ahora lo comento
procedure aplicarPropiedadesASeries(xls: TExcelFile; nombreHoja: String;
                                    tipoGraficoPrincipal: TTipoGrafico; tiposGraficos: TDAOfTTipoGrafico;
                                    ejes: TDAOfTTipoEje;
                                    colores: TDAOfTColor);
*)

(*
procedure chartMatAndCopyToWord(xls : TExcelFile;
                   nombreHoja: String; titulo, ejeY: String;
                   colIni, colFin, filaIni, filaFin: Integer;
                   minEjeYAuto, maxEjeYAuto: boolean;
                   minEjeY, MaxEjeY: NReal;
                   minEjeX, MaxEjeX: NReal;
                   WordApp: variant;
                   tipoGrafico: TTipoGrafico);
*)

procedure WriteMatToXLS(
  xls: TExcelFile;
  nombreHoja: string;
  mat: TMatOfNReal;
  titulo, unidades: string;
  nPasos: integer;
  nCronicas: integer;
  dtFechaPrimerPaso: TDateTime;
  dtPaso: double;
  digitos, decimales: integer;
  Print_Todas: boolean;
  Print_promedio: boolean;
  Print_probAisladas: TDAofNReal;
  chart_Mat: boolean;
  minEjeYAuto, maxEjeYAuto: boolean;
  minEjeY, MaxEjeY: NReal);

procedure writeHistogramaGlobalToXls(xls: TExcelFile;
                                     nombreHoja: String;
                                     mat: TMatOfNReal;
                                     titulo, unidades: string;
                                     digitos, decimales: integer;
                                     minX, maxX: NReal; nPuntos: Integer{;
                                     chart_Mat: boolean;
                                     minEjeYAuto, maxEjeYAuto: boolean;
                                     minEjeY, MaxEjeY: NReal});


  (*
procedure WriteMatToXLSAndCopyToWord(
  xls: TExcelFile;
  nombreHoja: string;
  mat: TMatOfNReal;
  titulo, unidades: string;
  nPasos: integer;
  nCronicas: integer;
  dtFechaPrimerPaso: TDateTime;
  dtPaso: double;
  digitos, decimales: integer;
  Print_Todas: boolean;
  Print_promedio: boolean;
  Print_probAisladas: TDAofNReal;
  chart_Mat: boolean;
  minEjeYAuto, maxEjeYAuto: boolean;
  minEjeY, MaxEjeY: NReal;
  WordApp: variant );
    *)

procedure WriteMatToXLS_SinOrdenar(
  xls: TExcelFile;
  nombreHoja: string;
  mat: TMatOfNReal;
  titulo, unidades: string;
  titulosCols: TDAofString;
  nPasos: integer;
  nCronicas: integer;
  dtFechaPrimerPaso: TDateTime;
  dtPaso: double;
  digitos, decimales: integer;
  Print_promedio: boolean;
  chart_Mat: boolean;
  minEjeYAuto, maxEjeYAuto: boolean;
  minEjeY, MaxEjeY: NReal);

(*
procedure WriteMatToXLSAndCopyToWord_SinOrdenar(
  xls: TExcelFile;
  nombreHoja: string;
  mat: TMatOfNReal;
  titulo, unidades: string;
  titulosCols: TDAofString;
  nPasos: integer;
  nCronicas: integer;
  dtFechaPrimerPaso: TDateTime;
  dtPaso: double;
  digitos, decimales: integer;
  Print_promedio: boolean;
  chart_Mat: boolean;
  minEjeYAuto, maxEjeYAuto: boolean;
  minEjeY, MaxEjeY: NReal;
  WordApp: variant );
  *)
  
procedure WriteValoresToXLS(
  xls: TExcelFile;
  tipoValores: TTipoValoresAComparar;
  probExcedencia: NReal;
  nombresVars: TDAofString;
  mats: array of TMatOfNReal;
  nombreHoja: string;
  titulo, unidades: string;
  dtFechaPrimerPaso: TDateTime;
  dtPaso: double;
  digitos, decimales: integer;
  graficar: boolean; tiposGraficos: TDAOfTTipoGrafico; ejes: TDAOfTTipoEje; colores: TDAOfTColor;
  minEjeYAuto, maxEjeYAuto: boolean;
  minEjeY, MaxEjeY: NReal);

function TTipoGraficoToXLConst(tipoGrafico: TTipoGrafico): Integer;
function TTipoGraficoToString(tipoGrafico: TTipoGrafico): String;
function StringToTTipoGrafico(tipoGrafico: String): TTipoGrafico;

function TTipoEjeToXLConst(tipoEje: TTipoEje): Integer;
function TTipoEjeToString(tipoEje: TTipoEje): String;
function StringToTTipoEje(tipoEje: String): TTipoEje;

function TTipoValoresACompararToString(tipoValoresAComparar: TTipoValoresAComparar): String;
function StringToTTipoValoresAComparar(tipoValoresAComparar: String): TTipoValoresAComparar;
function TTipoValoresACompararToShortStringSingular(tipoValoresAComparar: TTipoValoresAComparar; probExcedencia: NReal): String;



implementation

function nroColToExcelStrCol(nroCol: Integer) : String;
const
  ExcelCols = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
var
  iLetra: Integer;
  res: String;
begin
  res:= '';

  while nroCol > Length(ExcelCols) do
  begin
    iLetra:= nroCol div Length(ExcelCols);
    res:= res + ExcelCols[iLetra];
    nroCol:= nroCol - iLetra * Length(ExcelCols)
  end;
  res:= res + ExcelCols[nroCol];

  result:= res;
end;

procedure WriteMatToText(
  nombreArch: string;
  mat: TMatOfNReal;
  titulo: string;
  nPasos: integer;
  nCronicas: integer;
  dtFechaPrimerPaso: TDateTime;
  dtPaso: double;
  digitos, decimales: integer;
  Print_Todas: boolean;
  Print_promedio: boolean;
  Print_probAisladas: TDAofNReal );

var
  sal: textfile;
  iCronica, iPaso: integer;
  fechaDelPaso: TDateTime;
  iProbAisladas: array of integer;
  aprom: NReal;
  kProb: integer;
  hayAdicionales: boolean;
  aval: NReal;
begin
  setlength( iProbAisladas, length( Print_probAisladas ));
  for kProb:= 0 to high( Print_probAisladas ) do
  begin
    iCronica:= round( NCronicas * Print_probAisladas[kProb] )-1;
    if iCronica < 0 then iCronica:= 0;

    iProbAisladas[kProb]:= iCronica;
  end;

  hayAdicionales:= Print_promedio or ( length( Print_probAisladas ) > 0 );

  assignfile( sal, nombreArch+'_rpex.xlt' );
  rewrite( sal );

  writeln(sal, titulo );
  write(sal, 'paso' );

  if Print_Todas then
  begin
    write( sal, #9 );
    for iCronica:= 0 to NCronicas-1 do
      write( sal, #9, ((iCronica+1)/NCronicas*100):6:1,'%' );
  end;

  if hayAdicionales then
  begin
    write( sal, #9, #9 );
    if Print_Promedio then
      write( sal, #9, 'Prom' );
    for kProb:= 0 to high( iProbAisladas ) do
      write( sal, #9, 'Pe'+ FloatToStrF( Print_ProbAisladas[ kProb ]*100,ffFixed, 6,1 )+'%');
  end;

  writeln( sal );
  for iPaso:= 0 to NPasos-1 do
  begin
    QuickSort_Decreciente(mat[iPaso]);
    fechaDelPaso:= dtFechaPrimerPaso + dtPaso * iPaso;
    write(sal, iPaso );

    if Print_Todas then
      write( sal, #9, DateTimeToStr( fechaDelPaso ) );

    aProm:= 0;
    for iCronica:= 0 to NCronicas-1 do
    begin
      aval:= mat[iPaso][iCronica];
      if Print_Todas then
        write( sal, #9, FloatToStrF(aval , ffFixed, digitos, decimales ) );
      aProm:= aProm+ aval;
    end;
    aProm:= aProm / NCronicas;

    if hayAdicionales then
    begin
      write( sal, #9, #9, DateTimeToStr( fechaDelPaso ) );
      if Print_Promedio then
        write( sal, #9, FloatToStrF(aProm , ffFixed, digitos, decimales ));
      for kProb:= 0 to high( iProbAisladas ) do
        write( sal, #9, FloatToStrF(mat[iPaso][iProbAisladas[kProb]] , ffFixed, digitos, decimales ));
    end;
    writeln( sal );
  end;
  writeln( sal );
  closefile( sal );
end;

procedure chartMat(xls : TExcelFile;
                   nombreHoja: String; titulo, ejeY: String;
                   colIni, colFin, filaIni, filaFin: Integer;
                   minEjeYAuto, maxEjeYAuto: boolean;
                   minEjeY, MaxEjeY: NReal;
                   minEjeX, MaxEjeX: NReal;
                   tipoGrafico: TTipoGrafico);
var
  nombreHojaGrafico: Shortstring;
begin
  nombreHojaGrafico:= xf_graficar(nombreHoja,
                                  colIni, colFin, filaIni, filaFin);

  xf_aplicarPropiedadesAGrafico(nombreHojaGrafico,
                                TTipoGraficoToXLConst( TipoGrafico ),
                                titulo, ejeY, minEjeYAuto, maxEjeYAuto,
                                minEjeY, MaxEjeY, minEjeX, MaxEjeX);
end;

procedure chartMat(xls: TExcelFile;
                   nombreHoja: String; titulo, ejeY: String;
                   colIni, colFin, filaIni, filaFin: Integer;
                   minEjeYAuto, maxEjeYAuto: boolean;
                   minEjeY, MaxEjeY: NReal;
                   minEjeX, MaxEjeX: NReal;
                   tiposGraficos: TDAOfTTipoGrafico;
                   ejes: TDAOfTTipoEje;
                   colores: TDAOfTColor);
var
  nombreHojaGrafico: Shortstring;
  iterTipoGrafico, tipoGraficoPrincipal: TTipoGrafico;

  i, maxHistoTiposGraficos: Integer;
  histoTiposGraficos: array [TTipoGrafico] of Integer;
begin
  nombreHojaGrafico:= xf_graficar( nombreHoja,
                               colIni, colFin, filaIni, filaFin);

  for iterTipoGrafico:= low(histoTiposGraficos) to high(histoTiposGraficos) do
    histoTiposGraficos[iterTipoGrafico]:= 0;
  for i:= 0 to high(tiposGraficos) do
    histoTiposGraficos[tiposGraficos[i]]:= histoTiposGraficos[tiposGraficos[i]] + 1;

  maxHistoTiposGraficos:= 0;
  tipoGraficoPrincipal:= dispersion;
  for iterTipoGrafico:= low(histoTiposGraficos) to high(histoTiposGraficos) do
    if histoTiposGraficos[iterTipoGrafico] > maxHistoTiposGraficos then
    begin
      maxHistoTiposGraficos:= histoTiposGraficos[iterTipoGrafico];
      tipoGraficoPrincipal:= iterTipoGrafico;
    end;

  xf_aplicarPropiedadesAGrafico( nombreHojaGrafico,
                                 TTipoGraficoToXLConst(tipoGraficoPrincipal),
                                 titulo, ejeY, minEjeYAuto, maxEjeYAuto,
                                 minEjeY, MaxEjeY, minEjeX, MaxEjeX);

  for i:= 0 to high(tiposGraficos) do
  begin
    xf_aplicarPropiedadesASerie(nombreHojaGrafico, i + 1,
                                TTipoGraficoToXLConst(tipoGraficoPrincipal), TTipoGraficoToXLConst(tiposGraficos[i]),
                                TTipoEjeToXLConst(ejes[i]), colores[i]);
  end;

(*??? por ahora lo comento
  aplicarPropiedadesASeries(xls, nombreHojaGrafico, tipoGraficoPrincipal, tiposGraficos, ejes, colores);
  *)
end;

(*

procedure aplicarPropiedadesASeries(xls: TExcelFile; nombreHoja: String;
                                    tipoGraficoPrincipal: TTipoGrafico; tiposGraficos: TDAOfTTipoGrafico;
                                    ejes: TDAOfTTipoEje;
                                    colores: TDAOfTColor);
var
  hojag, serie: Variant;
  i: Integer;
  colorIndexI: Integer;
  versionOffice: NReal;
  aux: TPaletaColoresExcel;
begin
  hojag:= xls.Hoja(nombreHoja);

  versionOffice:= xls.version;
  if versionOffice < versionOffice2007 then
    aux:= xls.getPaletaColores;

  for i:= 0 to High(tiposGraficos) do
  begin
    serie:= hojag.SeriesCollection(i + 1);
    if tiposGraficos[i] <> tipoGraficoPrincipal then
      serie.ChartType:= TTipoGraficoToXLConst(tiposGraficos[i]);
    serie.AxisGroup:= TTipoEjeToXLConst(ejes[i]);

    if colores[i] <> colorAutomatico then
    begin
      if versionOffice < versionOffice2007 then
      begin
        colorIndexI:= getColorIndex(colores[i], aux);

        if tiposGraficos[i] in tiposGraficosConColorInterior then
          serie.Interior.Colorindex:= colorIndexI;
        serie.Border.Colorindex:= colorIndexI;
        if tiposGraficos[i] in tiposGraficosConMarcadores then
        begin
          serie.MarkerStyle:= xlAutomatic;
          serie.MarkerBackgroundColorIndex:= colorIndexI;
          serie.MarkerForegroundColorIndex:= colorIndexI;
        end;
      end
      else
      begin
        if tiposGraficos[i] in tiposGraficosConColorInterior then
          serie.Interior.Color:= colores[i];
        serie.Border.Color:= colores[i];
        if tiposGraficos[i] in tiposGraficosConMarcadores then
        begin
          serie.MarkerStyle:= xlAutomatic;
          serie.MarkerBackgroundColor:= colores[i];
          serie.MarkerForegroundColor:= colores[i];
        end;
      end;
    end;
  end;
end;

procedure chartMatAndCopyToWord(xls : TExcelFile;
                   nombreHoja: String; titulo, ejeY: String;
                   colIni, colFin, filaIni, filaFin: Integer;
                   minEjeYAuto, maxEjeYAuto: boolean;
                   minEjeY, MaxEjeY: NReal;
                   minEjeX, MaxEjeX: NReal;
                   WordApp: variant;
                   tipoGrafico: TTipoGrafico);
var
{$IFDEF SAQUEWORD}
  NumPars, i: Integer;
{$ENDIF}
  ARange: Variant;
  hoja, hojag: Variant;
  celdaIni, celdaFin: String;
begin
  hoja:= xls.Hoja(nombreHoja);
  xls.v.Workbooks[1].Sheets.Add(,,1,xlChart);
  hojag:= xls.v.Workbooks[1].Sheets[1];
  hojag.Name:= 'g' + nombreHoja;

  hojag.ChartType:= TTipoGraficoTOXLConst(tipoGrafico);
  celdaIni:= nroColToExcelStrCol(colIni) + IntToStr(filaIni);
  celdaFin:= nroColToExcelStrCol(colFin) + IntToStr(filaFin);
  ARange:= hoja.Range[celdaIni + ':' + celdaFin];

  hojag.SetSourceData( ARange, xlColumns );

  if titulo <> '' then
  begin
    hojag.HasTitle:= True;
    hojag.ChartTitle.Characters.Text:= titulo;
  end;
  hojag.Axes(xlCategory, xlPrimary).HasTitle:= False;
  if ejeY <> '' then
  begin
    hojag.Axes(xlValue, xlPrimary).HasTitle:= True;
    hojag.Axes(xlValue, xlPrimary).AxisTitle.Characters.Text:= ejeY;
  end;

  hojag.PlotArea.Interior.ColorIndex:= 2;       //Color de fondo blanco
  if minEjeYAuto then
    hojag.Axes(xlValue).MinimumScaleIsAuto:= true
  else
    hojag.Axes(xlValue).MinimumScale:= minEjeY;   //Mnimo del eje Y
  if maxEjeYAuto then
    hojag.Axes(xlValue).MaximumScaleIsAuto:= true
  else
    hojag.Axes(xlValue).MaximumScale:= MaxEjeY;   //Mximo del eje Y

  hojag.Axes(xlCategory).MinimumScale:= minEjeX;
  hojag.Axes(xlCategory).MaximumScale:= maxEjeX;
//  hojag.Axes(xlValue).MinorUnitIsAuto:= false;
//  hojag.Axes(xlValue).MajorUnitIsAuto:= false;
//        .MinorUnit = 2
//        .MajorUnit = 5

  hojag.ChartArea.Select;
  xls.v.Selection.Copy;

{$IFDEF SAQUEWORD}
  NumPars := WordApp.Documents.Item(1).Paragraphs.Count;

  for i := 1 to 3 do WordApp.Documents.Item(1).Paragraphs.Add;

  ARange := WordApp.Documents.Item(1).Range(
    WordApp.Documents.Item(1).Paragraphs.Item(NumPars + 1).Range.Start,
    WordApp.Documents.Item(1).Paragraphs.Item(NumPars + 1).Range.End);

  ARange.Paste;
{$ENDIF}

//  ARange.PasteSpecial(,,,,wdPasteOleObject);
  // ARange.PasteAndFormat(wdChartPicture);
//  ARange.Select;

//  WordApp.Documents.Item(1).Paragraphs.Item(NumPars + 1).Range.select;
//  WordApp.Documents.Item(1).Charts(1).Select;
//  WordApp.Selection.ShapeRange.WrapFormat.Type := wdWrapTopBottom;

{    XLApp.Workbooks[1].Sheets.Add(,,1,xlChart);
  Sheets := XLApp.Sheets;
  ARange := Sheets.Item['Delphi Data'].Range['A1:A10'];
  Sheets.Item[1{'Chart1'}{].SeriesCollection.Item[1].Values := ARange;
  Sheets.Item[1].ChartType := xl3DPie;
  Sheets.Item[1].SeriesCollection.Item[1].HasDataLabels := True;

  XLApp.Workbooks[1].Sheets.Add(,,1,xlChart);
  Sheets.Item[2].SeriesCollection.Item[1].Values := ARange;
  Sheets.Item[2].SeriesCollection.Add(ARange);
  Sheets.Item[2].SeriesCollection.NewSeries;
  Sheets.Item[2].SeriesCollection.Item[1].Values :=
    VarArrayOf([1,2,3,4,5, 6,7,8,9,10]);
  Sheets.Item[2].ChartType := xl3DColumn;}
end;
*)


(*
procedure WriteMatToXLSAndCopyToWord(
  xls: TExcelFile;
  nombreHoja: string;
  mat: TMatOfNReal;
  titulo, unidades: string;
  nPasos: integer;
  nCronicas: integer;
  dtFechaPrimerPaso: TDateTime;
  dtPaso: double;
  digitos, decimales: integer;
  Print_Todas: boolean;
  Print_promedio: boolean;
  Print_probAisladas: TDAofNReal;
  chart_Mat: boolean;
  minEjeYAuto, maxEjeYAuto: boolean;
  minEjeY, MaxEjeY: NReal;
  WordApp: variant );

var
  iCronica, iPaso: integer;
  fechaDelPaso: TDateTime;
  iProbAisladas: array of integer;
  aprom: NReal;
  kProb: integer;
  hayAdicionales: boolean;
  aval: NReal;
  colIni, colFin, filaIni, filaFin: Integer;
begin
  setlength( iProbAisladas, length( Print_probAisladas ));
  for kProb:= 0 to high( Print_probAisladas ) do
  begin
    iCronica:= round( NCronicas * Print_probAisladas[kProb] )-1;
    if iCronica < 0 then iCronica:= 0;

    iProbAisladas[kProb]:= iCronica;
  end;

  hayAdicionales:= Print_promedio or ( length( Print_probAisladas ) > 0 );

  xls.agregoHoja( nombreHoja );
  xls.go( nombreHoja, 1, 1);

  xls.writeln( titulo + ' ' + unidades);

  //Para evitar el warning
  colIni:= -1;
  colFin:= -1;

  filaIni:= xls.fila;
  filaFin:= filaIni + nPasos;

  xls.WriteBuffereado( 'paso' );

  if Print_Todas then
  begin
    colIni:= xls.columnaBuffereada;
    colFin:= colIni + nCronicas;

    xls.WriteBuffereado( '' );
    for iCronica:= 0 to NCronicas-1 do
      xls.WriteBuffereado( FloatToStrF( (iCronica+1)/NCronicas*100, ffFixed, 6,1 )+'%' );
  end;

  if hayAdicionales then
  begin
    xls.WriteBuffereado('');

    colIni:= xls.columnaBuffereada;
    colFin:= colIni + Length(Print_ProbAisladas);
    if Print_promedio then
      inc(colFin);
    filaIni:= xls.fila;
    filaFin:= filaIni + nPasos;

    xls.WriteBuffereado('' );
    if Print_Promedio then
      xls.WriteBuffereado( 'Prom' );
    for kProb:= 0 to high( iProbAisladas ) do
      xls.WriteBuffereado( FloatToStrF( Print_ProbAisladas[ kProb ]*100,ffFixed, 6,1 )+'%');
  end;

  xls.WriteLnBuffer;
  for iPaso:= 0 to NPasos-1 do
  begin
    QuickSort_Decreciente(mat[iPaso] );
    fechaDelPaso:= dtFechaPrimerPaso+  dtPaso * iPaso;
    xls.WriteBuffereado( IntToStr( iPaso + 1) );

    if Print_Todas then
      xls.WriteBuffereado( DateTimeToIsoStr( fechaDelPaso ) );

    aProm:= 0;
    for iCronica:= 0 to NCronicas-1 do
    begin
      aval:= mat[iPaso][iCronica];
      if Print_Todas then
        xls.WriteBuffereado(  FloatToStrF(aval , ffFixed, digitos, decimales ) );
      aProm:= aProm + aval;
    end;
    aProm:= aProm / NCronicas;

    if hayAdicionales then
    begin
      xls.WriteBuffereado( '' ); xls.WriteBuffereado(  DateTimeToIsoStr( fechaDelPaso ) );
      if Print_Promedio then
        xls.WriteBuffereado( FloatToStrF(aProm , ffFixed, digitos, decimales ));
      for kProb:= 0 to high( iProbAisladas ) do
        xls.WriteBuffereado( FloatToStrF(mat[iPaso][iProbAisladas[kProb]] , ffFixed, digitos, decimales ));
    end;
    xls.WriteLnBuffer;
  end;
  xls.writeln( '' );

  if chart_Mat then
  begin
    chartMatAndCopyToWord(xls,
             nombreHoja, titulo, unidades,
             colIni, colFin, filaIni, filaFin,
             minEjeYAuto, maxEjeYAuto,
             minEjeY, MaxEjeY,
             dtFechaPrimerPaso, dtFechaPrimerPaso + (nPasos - 1) * dtPaso,
             WordApp, dispersion);
  end;
end;
*)

procedure WriteMatToXLS(
  xls: TExcelFile;
  nombreHoja: string;
  mat: TMatOfNReal;
  titulo, unidades: string;
  nPasos: integer;
  nCronicas: integer;
  dtFechaPrimerPaso: TDateTime;
  dtPaso: double;
  digitos, decimales: integer;
  Print_Todas: boolean;
  Print_promedio: boolean;
  Print_probAisladas: TDAofNReal;
  chart_Mat: boolean;
  minEjeYAuto, maxEjeYAuto: boolean;
  minEjeY, MaxEjeY: NReal);
var
  iCronica, iPaso: integer;
  fechaDelPaso: TDateTime;
  iProbAisladas: array of integer;
  aprom: NReal;
  kProb: integer;
  hayAdicionales: boolean;
  aval: NReal;
  colIni, colFin, filaIni, filaFin: Integer;
begin
  setlength( iProbAisladas, length( Print_probAisladas ));
  for kProb:= 0 to high( Print_probAisladas ) do
  begin
    iCronica:= round( NCronicas * Print_probAisladas[kProb] )-1;
    if iCronica < 0 then iCronica:= 0;

    iProbAisladas[kProb]:= iCronica;
  end;

  hayAdicionales:= Print_promedio or ( length( Print_probAisladas ) > 0 );

  xls.agregoHoja( nombreHoja );
  xls.go( nombreHoja, 1, 1);

  xls.writeln( titulo + ' ' + unidades);

  //Para evitar el warning
  colIni:= -1;
  colFin:= -1;

  filaIni:= xls.fila;
  filaFin:= filaIni + nPasos;

  xls.Write_buffereado( 'paso' );

  if Print_Todas then
  begin
    colIni:= xls.columnaBuffereada;  
    colFin:= colIni + nCronicas;
    xls.Write_buffereado( '' );
    for iCronica:= 0 to NCronicas-1 do
      xls.Write_buffereado( FloatToStrF( (iCronica+1)/NCronicas*100, ffFixed, 6,1 )+'%' );
  end;

  if hayAdicionales then
  begin
    xls.Write_buffereado('');

    colIni:= xls.columnaBuffereada;
    colFin:= colIni + Length(Print_ProbAisladas);
    if Print_promedio then
      inc(colFin);
    filaIni:= xls.fila;
    filaFin:= filaIni + nPasos;

    xls.Write_buffereado('' );
    if Print_Promedio then
      xls.Write_buffereado( 'Prom' );
    for kProb:= 0 to high( iProbAisladas ) do
//rch      xls.Write_buffereado( FloatToStrF( Print_ProbAisladas[ kProb ]*100,ffFixed, 6,1 )+'%');
      xls.Write_buffereado( Print_ProbAisladas[ kProb ]);
  end;
  xls.writelnBuffer;
  
  for iPaso:= 0 to NPasos-1 do
  begin
    QuickSort_Decreciente(mat[iPaso] );
    fechaDelPaso:= dtFechaPrimerPaso + dtPaso * iPaso;
    xls.Write_buffereado( IntToStr( iPaso + 1) );

    if Print_Todas then
      xls.Write_buffereado( DateTimeToIsoStr( fechaDelPaso ) );

    aProm:= 0;
    if Print_Todas or Print_promedio then
    begin
      for iCronica:= 0 to NCronicas-1 do
      begin
        aval:= mat[iPaso][iCronica];
        if Print_Todas then
          xls.Write_buffereado(  FloatToStrF(aval , ffFixed, digitos, decimales ) );
        aProm:= aProm+ aval;
      end;
      aProm:= aProm / NCronicas;
    end;

    if hayAdicionales then
    begin
      xls.Write_buffereado( '' );
      xls.Write_buffereado(  DateTimeToIsoStr( fechaDelPaso ) );
      if Print_Promedio then
        xls.Write_buffereado( FloatToStrF(aProm , ffFixed, digitos, decimales ));
      for kProb:= 0 to high( iProbAisladas ) do
        xls.Write_buffereado( FloatToStrF(mat[iPaso][iProbAisladas[kProb]] , ffFixed, digitos, decimales ));
    end;
    xls.writelnBuffer;
  end;
  xls.writelnBuffer;

  if chart_Mat then
  begin
    chartMat(xls,
             nombreHoja, titulo, unidades,
             colIni, colFin, filaIni, filaFin,
             minEjeYAuto, maxEjeYAuto,
             minEjeY, MaxEjeY,
             dtFechaPrimerPaso, dtFechaPrimerPaso + (nPasos - 1) * dtPaso,
             dispersion);
  end;
end;


procedure writeHistogramaGlobalToXls(xls: TExcelFile;
                                     nombreHoja: String;
                                     mat: TMatOfNReal;
                                     titulo, unidades: string;
                                     digitos, decimales: integer;
                                     minX, maxX: NReal; nPuntos: Integer{;
                                     chart_Mat: boolean;
                                     minEjeYAuto, maxEjeYAuto: boolean;
                                     minEjeY, MaxEjeY: NReal});
var
  i, j, idxVal: Integer;
//  min, max: NReal;
  histo, histoAcum: TDAofNReal;
  x, invNPuntosCronicas, deltaMaxMin, invDeltaMaxMin, deltaX: NReal;

//  filaContenido: TDAOfVariant;

  //  filaIni, filaFin, colIni, colFin: Integer;
begin
{  min:= MaxNReal;
  max:= -MaxNReal;
  for i:= 0 to high(mat) do
  begin
    for j:= 0 to high(mat[i]) do
    begin
      if mat[i][j] < min then
        min:= mat[i][j];
      if mat[i][j] > max then
        max:= mat[i][j];
    end;
  end;}
  deltaMaxMin:= maxX - minX;
  invDeltaMaxMin:= 1 / deltaMaxMin;
  deltaX:= deltaMaxMin / (nPuntos - 1);
  invNPuntosCronicas:= 1 / (length(mat) * length(mat[0]));
  SetLength(histo, nPuntos);
  for i:= 0 to high(histo) do
    histo[i]:= 0;

  for i:= 0 to high(mat) do
  begin
    for j:= 0 to high(mat[i]) do
    begin
      idxVal:= trunc(((mat[i][j] - minX) * invDeltaMaxMin) * high(histo));
      if idxVal < 0 then
        idxVal:= 0
      else if idxVal > high(histo) then
        idxVal:= high(histo);

      histo[idxVal]:= histo[idxVal] + invNPuntosCronicas;
    end;
  end;

  SetLength(histoAcum, length(histo));
  histoAcum[0]:= histo[0];
  for i:= 1 to high(histoAcum) do
    histoAcum[i]:= histoAcum[i - 1] + histo[i];
//  QuickSort_Decreciente(histo);

  xls.agregoHoja( nombreHoja );
  xls.go( nombreHoja, 1, 1);

  xls.writeln( titulo + ' ' + unidades);

{  filaIni:= xls.fila;
  filaFin:= filaIni + length(histoAcum) + 1;
  colIni:= xls.columnaBuffereada;
  colFin:= colIni + 1;}

  xls.Write_buffereado(titulo);
  xls.Write_buffereado('Probabilidad Acumulada');
  xls.writelnBuffer;
  x:= minX;

  for i:= 0 to high(histoAcum) do
  begin
    xls.Write_buffereado(FloatToStrF( x, ffFixed, digitos, decimales ));
    xls.Write_buffereado( FloatToStrF( histoAcum[i], ffFixed, digitos, decimales ) );
    xls.writelnBuffer;
    x:= x + deltaX;
  end;

{  if chart_Mat then
  begin
    chartMat(xls, nombreHoja, titulo, unidades, colIni, colFin, filaIni, filaFin,
    minEjeYAuto, maxEjeYAuto, minEjeY, MaxEjeY, 1/ Length(histo), 1, dispersion);
  end;}
end;

procedure WriteMatToXLS_SinOrdenar(
  xls: TExcelFile;
  nombreHoja: string;
  mat: TMatOfNReal;
  titulo, unidades: string;
  titulosCols: TDAofString;
  nPasos: integer;
  nCronicas: integer;
  dtFechaPrimerPaso: TDateTime;
  dtPaso: double;
  digitos, decimales: integer;
  Print_promedio: boolean;
  chart_Mat: boolean;
  minEjeYAuto, maxEjeYAuto: boolean;
  minEjeY, MaxEjeY: NReal);
var
  iCronica, iPaso: integer;
  fechaDelPaso: TDateTime;
  aprom: NReal;
  aval: NReal;
  colIni, colFin, filaIni, filaFin: Integer;

  nHojas, kHoja: integer;
  iCronIni, iCronM, iCronFin: integer;
  sNombreHoja: string;
begin
  //Para sacar el warning
  colIni:= -1;
  filaIni:= -1;

  nHojas:= ((nCronicas-1) div 250)+1;

  for kHoja:= 1 to nHojas do
  begin
    if ( nHojas > 1 ) then  
      sNombreHoja:=nombreHoja+'_'+IntToStr( kHoja )
    else
      sNombreHoja:=nombreHoja;

    xls.agregoHoja( sNombreHoja );

    iCronIni:= (kHoja-1) * 250;
    iCronFin:= min( (nCronicas-1), iCronIni + 250 -1 );
    iCronM:= max( iCronIni-1, min( high(titulosCols), iCronFin ));

    xls.go( sNombreHoja, 1, 1);
    xls.writeln( titulo + ' ' + unidades);

    xls.Write_buffereado( 'paso' );

    filaIni:= xls.fila;
    filaFin:= filaIni + nPasos;
    colIni:= xls.columnaBuffereada;
    colFin:= colIni + iCronFin - iCronIni +1;
    xls.Write_buffereado( '' );


    for iCronica:= iCronIni to iCronM do
      xls.Write_buffereado( titulosCols[iCronica] );
    //Si faltaron titulos de columnas como parametro imprime Columna y su nmero
    for iCronica:= iCronM+1 to iCronFin  do
      xls.Write_buffereado( 'Col_' + IntToStr(iCronica + 1) );

    if Print_promedio then
    begin
      inc(colFin);
      xls.Write_buffereado( 'Prom' );
    end;

    xls.writelnBuffer;
    for iPaso:= 0 to NPasos-1 do
    begin
      fechaDelPaso:= dtFechaPrimerPaso + dtPaso * iPaso;
      xls.Write_buffereado( IntToStr( iPaso + 1) );
      xls.Write_buffereado( DateTimeToIsoStr( fechaDelPaso ) );

      aProm:= 0;
        for iCronica:= iCronIni to iCronFin do
      begin
        aval:= mat[iPaso][iCronica];
        xls.Write_buffereado( FloatToStrF(aval , ffFixed, digitos, decimales) );
        aProm:= aProm+ aval;
      end;
      aProm:= aProm / NCronicas;

      if Print_Promedio then
        xls.Write_buffereado( FloatToStrF(aProm , ffFixed, digitos, decimales ));
      xls.writelnBuffer;
    end;
    xls.writelnBuffer;
  end;
  xls.writelnBuffer;

  if (nHojas= 1 ) and chart_Mat then
  begin
    chartMat(xls,
             nombreHoja, titulo, unidades,
             colIni, colFin, filaIni, filaFin,
             minEjeYAuto, maxEjeYAuto,
             minEjeY, MaxEjeY,
             dtFechaPrimerPaso, dtFechaPrimerPaso + (nPasos - 1) * dtPaso, dispersion);
  end;
end;

(*
procedure WriteMatToXLSAndCopyToWord_SinOrdenar(
  xls: TExcelFile;
  nombreHoja: string;
  mat: TMatOfNReal;
  titulo, unidades: string;
  titulosCols: TDAofString;  
  nPasos: integer;
  nCronicas: integer;
  dtFechaPrimerPaso: TDateTime;
  dtPaso: double;
  digitos, decimales: integer;
  Print_promedio: boolean;
  chart_Mat: boolean;
  minEjeYAuto, maxEjeYAuto: boolean;
  minEjeY, MaxEjeY: NReal;
  WordApp: variant );
var
  iCronica, iPaso: integer;
  fechaDelPaso: TDateTime;
  aprom: NReal;
  aval: NReal;
  colIni, colFin, filaIni, filaFin: Integer;
begin
  xls.agregoHoja( nombreHoja );
  xls.go( nombreHoja, 1, 1);

  xls.writeln( titulo + ' ' + unidades);

  xls.Write( 'paso' );

  filaIni:= xls.fila;
  filaFin:= filaIni + nPasos;
  colIni:= xls.columna;
  colFin:= colIni + nCronicas;
  xls.Write( '' );
  for iCronica:= 0 to high(titulosCols) do
    xls.Write( titulosCols[iCronica] );
  //Si faltaron titulos de columnas como parametro imprime Columna y su nmero
  for iCronica:= Length(titulosCols) to nCronicas -1  do
    xls.Write( 'Columna' + IntToStr(iCronica + 1) );

  if Print_promedio then
  begin
    inc(colFin);
    xls.Write( 'Prom' );
  end;

  xls.WriteLn;
  for iPaso:= 0 to NPasos-1 do
  begin
    fechaDelPaso:= dtFechaPrimerPaso + dtPaso * iPaso;
    xls.Write( IntToStr( iPaso + 1) );
    xls.Write( DateTimeToIsoStr( fechaDelPaso ) );

    aProm:= 0;
    for iCronica:= 0 to NCronicas-1 do
    begin
      aval:= mat[iPaso][iCronica];
      xls.Write( FloatToStrF(aval , ffFixed, digitos, decimales) );
      aProm:= aProm+ aval;
    end;
    aProm:= aProm / NCronicas;

    if Print_Promedio then
      xls.Write( FloatToStrF(aProm , ffFixed, digitos, decimales ));
    xls.WriteLn;
  end;
  xls.writeln( '' );

  if chart_Mat then
  begin
    chartMatAndCopyToWord(xls,
                          nombreHoja, titulo, unidades,
                          colIni, colFin, filaIni, filaFin,
                          minEjeYAuto, maxEjeYAuto,
                          minEjeY, MaxEjeY,
                          dtFechaPrimerPaso, dtFechaPrimerPaso + (nPasos - 1) * dtPaso,
                          WordApp, dispersion);
  end;
end;
*)

procedure calcPromedios(const mats: array of TMatOfNReal; iPaso: Integer; var resultado: TDAofNReal);
var
  i: Integer;
begin
  for i:= 0 to high(mats) do
    resultado[i]:= vprom(mats[i][iPaso]);
end;

procedure calcDesviacionesEstandar(const mats: array of TMatOfNReal; iPaso: Integer; var resultado: TDAofNReal);
var
  i, j: Integer;
  filaPaso, proms: TDAofNReal;
begin
  SetLength(proms, length(mats));
  calcPromedios(mats, iPaso, proms);

  for i:= 0 to high(mats) do
  begin
    filaPaso:= mats[i][iPaso];
    resultado[i]:= 0;
    for j:= 0 to High(filaPaso) do
      resultado[i]:= resultado[i] + Sqr(filaPaso[j] - proms[i]);
    resultado[i]:= resultado[i] / (Length(filaPaso) - 1);
  end;
  SetLength(proms, 0);
end;

procedure calcProbsExcedencia(const mats: array of TMatOfNReal; iPaso: Integer; probExcedencia: NReal; var resultado: TDAofNReal);
var
  i, iProbExcedencia: Integer;
  filaPaso: TDAofNReal;
begin
  for i:= 0 to high(mats) do
  begin
    filaPaso:= copy(mats[i][iPaso], 0, length(mats[i][iPaso]));
    QuickSort_Decreciente(filaPaso);
    iProbExcedencia:= round( length(filaPaso) * probExcedencia ) - 1;

    resultado[i]:= filaPaso[iProbExcedencia];
  end;
end;

procedure WriteValoresToXLS(
  xls: TExcelFile;
  tipoValores: TTipoValoresAComparar;
  probExcedencia: NReal;  
  nombresVars: TDAofString;
  mats: array of TMatOfNReal;
  nombreHoja: string;
  titulo, unidades: string;
  dtFechaPrimerPaso: TDateTime;
  dtPaso: double;
  digitos, decimales: integer;
  graficar: boolean; tiposGraficos: TDAOfTTipoGrafico; ejes: TDAOfTTipoEje; colores: TDAOfTColor;
  minEjeYAuto, maxEjeYAuto: boolean;
  minEjeY, MaxEjeY: NReal);
var
  iPaso, iMats: Integer;
  valores: TDAofNReal;
  descTipoValor: String;
  colIni, colFin, filaIni, filaFin: Integer;  
begin
  xls.agregoHoja( nombreHoja );
  xls.go( nombreHoja, 1, 1);

  xls.writeln( titulo + ' ' + unidades);

  xls.Write_buffereado( 'paso' );

  filaIni:= xls.fila;
  filaFin:= filaIni + Length(mats[0]);
  colIni:= xls.columnaBuffereada;
  colFin:= colIni + length(mats);

  xls.Write_buffereado('fecha');
  descTipoValor:= TTipoValoresACompararToShortStringSingular(tipoValores, probExcedencia);
  for iMats:= 0 to high(mats) do
    xls.Write_buffereado(nombresVars[iMats] + '_' + descTipoValor);
  xls.writelnBuffer;

  SetLength(valores, length(mats));
  for iPaso:= 0 to high(mats[0]) do
  begin
    case tipoValores of
      Promedios                   : calcPromedios(mats, iPaso, valores);
      DesviacionesEstandar        : calcDesviacionesEstandar(mats, iPaso, valores);
      ProbabilidadesDeExcedencia  : calcProbsExcedencia(mats, iPaso, probExcedencia, valores);
    end;

    xls.Write_buffereado(iPaso + 1);
    xls.Write_buffereado(DateTimeToIsoStr(dtFechaPrimerPaso + iPaso * dtPaso));
    for iMats:= 0 to high(valores) do
      xls.Write_buffereado(valores[iMats]);
    xls.writelnBuffer;
  end;

  if graficar then
  begin
    chartMat(xls,
             nombreHoja, titulo, unidades,
             colIni, colFin, filaIni, filaFin,
             minEjeYAuto, maxEjeYAuto,
             minEjeY, MaxEjeY,
             dtFechaPrimerPaso, dtFechaPrimerPaso + (high(mats[0]) * dtPaso),
             tiposGraficos, ejes, colores);
  end;
end;

function TTipoGraficoToXLConst(tipoGrafico: TTipoGrafico): Integer;
begin
  case tipoGrafico of
//    linea           : result:= xlLineMarkers;
    dispersion      : result:= xlXYScatterLines;
    areaApilada     : result:= xlAreaStacked;
  else
    raise Exception.Create('uPrint.TTipoGraficoToXLConst: TTipoGrafico desconocido ' + IntToStr(ord(tipoGrafico)));
  end;
end;

function TTipoGraficoToString(tipoGrafico: TTipoGrafico): String;
begin
  case tipoGrafico of
//    linea       : result:= 'Lneas';
    dispersion  : result:= 'Dispersin';
    areaApilada : result:= 'Areas Apiladas';
    else
      raise Exception.Create('uPrint.TTipoGraficoToString: tipo de grafico desconocido ' + IntToStr(ord(tipoGrafico)));
  end;
end;

function StringToTTipoGrafico(tipoGrafico: String): TTipoGrafico;
begin
{  if AnsiCompareStr(tipoGrafico, 'Lneas') = 0 then
    result:= linea
  else }if AnsiCompareStr(tipoGrafico, 'Dispersin') = 0 then
    result:= dispersion
  else if AnsiCompareStr(tipoGrafico, 'Areas Apiladas') = 0 then
    result:= areaApilada
  else
    raise Exception.Create('uPrint.StringToTTipoGrafico: tipo de grfico desconocido ' + tipoGrafico);
end;

function TTipoEjeToXLConst(tipoEje: TTipoEje): Integer;
begin
  case tipoEje of
    Primario    : result:= 1;
    Secundario  : result:= 2;
  else
    raise Exception.Create('uPrint.TTipoEjeToXLConst: tipo de eje desconocido ' + IntToStr(ord(tipoEje)));
  end
end;

function TTipoEjeToString(tipoEje: TTipoEje): String;
begin
  case tipoEje of
    Primario    : result:= 'Primario';
    Secundario  : result:= 'Secundario';
  else
    raise Exception.Create('uPrint.TTipoEjeToXLConst: tipo de eje desconocido ' + IntToStr(ord(tipoEje)));    
  end;
end;

function StringToTTipoEje(tipoEje: String): TTipoEje;
begin
  if AnsiCompareStr(tipoEje, 'Primario') = 0 then
    result:= Primario
  else if AnsiCompareStr(tipoEje, 'Secundario') = 0 then
    result:= Secundario
  else
    raise Exception.Create('StringToTTipoEje: tipo de eje desconocido ' + tipoEje);
end;

function TTipoValoresACompararToString(tipoValoresAComparar: TTipoValoresAComparar): String;
begin
  case tipoValoresAComparar of
    Promedios                   : result:= 'Promedios';
    DesviacionesEstandar        : result:= 'Desviaciones Estandar';
    ProbabilidadesDeExcedencia  : result:= 'Probabilidades de Excedencia';
    else
      raise Exception.Create('uPrintCronVars.TTipoValoresACompararToString: tipo de grafico desconocido ' + IntToStr(ord(tipoValoresAComparar)));
  end;
end;

function StringToTTipoValoresAComparar(tipoValoresAComparar: String): TTipoValoresAComparar;
begin
  if AnsiCompareStr(tipoValoresAComparar, 'Promedios') = 0 then
    result:= Promedios
  else if AnsiCompareStr(tipoValoresAComparar, 'Desviaciones Estandar') = 0 then
    result:= DesviacionesEstandar
  else if AnsiCompareStr(tipoValoresAComparar, 'Probabilidades de Excedencia') = 0 then
    result:= ProbabilidadesDeExcedencia
  else
    raise Exception.Create('uPrintCronVars.StringToTTipoValoresAComparar: tipo de grfico desconocido ' + tipoValoresAComparar);
end;

function TTipoValoresACompararToShortStringSingular(tipoValoresAComparar: TTipoValoresAComparar; probExcedencia: NReal): String;
begin
  case tipoValoresAComparar of
    Promedios                   : result:= 'Prom';
    DesviacionesEstandar        : result:= 'DesvStd';
    ProbabilidadesDeExcedencia  : result:= 'P.E. ' + FloatToStrF(probExcedencia * 100, ffFixed, 6, 2) + '%';
    else
      raise Exception.Create('uPrintCronVars.TTipoValoresACompararToShortStringSingular: tipo de grafico desconocido ' + IntToStr(ord(tipoValoresAComparar)));
  end;
end;

end.
